/*
 * (C) Copyright 2016
 *Allwinner Technology Co., Ltd. <www.allwinnertech.com>
 *zhouhuacai <zhouhuacai@allwinnertech.com>
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#ifndef __WINE_CONFIG_H
#define __WINE_CONFIG_H

#include <asm/arch/platform.h>	/* get chip and board defs */

#undef DEBUG

#ifndef __KERNEL__
#define __KERNEL__
#endif
/*#define CONFIG_SUNXI_CMD_DMA*/
/*#define DEBUG*/
/*#define FPGA_PLATFORM*/
#define CONFIG_SUNXI_CRASH

/*
 * High Level Configuration Options
 */
#define CONFIG_ALLWINNER			/* It's a Allwinner chip */
#define	CONFIG_SUNXI				/* which is sunxi family */


/*u-boot defconfig*/
#define LINUX_MACHINE_ID        4137
#define UBOOT_VERSION			"3.0.0"
#define UBOOT_PLATFORM		    "1.0.0"
#define CONFIG_SYS_GENERIC_BOARD
#define HAVE_VENDOR_COMMON_LIB

#define CONFIG_NR_DRAM_BANKS               1
#define PHYS_SDRAM_1                       SDRAM_OFFSET(0x00000000)	/* SDRAM Bank #1 */
#define PHYS_SDRAM_1_SIZE                  (512 << 20)				/* 512 MB Bank #1 */

#define DRAM_PARA_STORE_ADDR               SDRAM_OFFSET(0x00800000)
/* memtest works on */
#define CONFIG_SYS_MEMTEST_START           SDRAM_OFFSET(0x00000000)
#define CONFIG_SYS_MEMTEST_END             SDRAM_OFFSET(0x02000000)	/* 256M */

#define TOC0_MMU_BASE_ADDRESS              SDRAM_OFFSET(0x02800000)
#define CONFIG_BOOTPKG_STORE_IN_DRAM_BASE  SDRAM_OFFSET(0x02e00000)

#define SUNXI_LOGO_COMPRESSED_LOGO_SIZE_ADDR            SDRAM_OFFSET(0x03000000)
#define SUNXI_LOGO_COMPRESSED_LOGO_BUFF                 SDRAM_OFFSET(0x03000010)
#define SUNXI_SHUTDOWN_CHARGE_COMPRESSED_LOGO_SIZE_ADDR SDRAM_OFFSET(0x03100000)
#define SUNXI_SHUTDOWN_CHARGE_COMPRESSED_LOGO_BUFF  	SDRAM_OFFSET(0x03100010)
#define SUNXI_ANDROID_CHARGE_COMPRESSED_LOGO_SIZE_ADDR  SDRAM_OFFSET(0x03200000)
#define SUNXI_ANDROID_CHARGE_COMPRESSED_LOGO_BUFF   	SDRAM_OFFSET(0x03200010)

/* fdt addr for kernel */
#define CONFIG_SUNXI_FDT_ADDR              SDRAM_OFFSET(0x04000000)

/*#define CONFIG_SUNXI_LOGBUFFER*/
#define SUNXI_DISPLAY_FRAME_BUFFER_ADDR    SDRAM_OFFSET(0x02020000)
#define SUNXI_DISPLAY_FRAME_BUFFER_SIZE    0x01000000

/* trusted dram:0x08000000~0x09000000 */
#define PLAT_TRUSTED_DRAM_BASE             SDRAM_OFFSET(0x08000000)
#define PLAT_TRUSTED_DRAM_SIZE             0x01000000


/* define malloc space,Size of malloc pool */
#define CONFIG_NONCACHE_MEMORY
#define CONFIG_NONCACHE_MEMORY_SIZE        (8 * 1024 * 1024)
#define CONFIG_SYS_MALLOC_LEN              (CONFIG_ENV_SIZE + (20 << 20))


/* for usb efex -- tools private data */
#define SRAM_AREA_A		                    CONFIG_SYS_SRAM_BASE

/* the sram base address, and the stack address in stage1 */
#define CONFIG_SYS_INIT_RAM_ADDR	     CONFIG_SYS_SRAM_BASE
#define CONFIG_SYS_INIT_RAM_SIZE	     CONFIG_SYS_SRAM_SIZE

#define CONFIG_SYS_INIT_SP_OFFSET \
	(CONFIG_SYS_INIT_RAM_SIZE - GENERATED_GBL_DATA_SIZE)
#define CONFIG_SYS_INIT_SP_ADDR \
	(CONFIG_SYS_INIT_RAM_ADDR + CONFIG_SYS_INIT_SP_OFFSET)


/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define CONFIG_SYS_NO_FLASH

#define CONFIG_SYS_MONITOR_LEN		(256 << 10)	/* 256 KiB */
#define CONFIG_IDENT_STRING			" Allwinner Technology "

#define CONFIG_ENV_IS_IN_SUNXI_FLASH	/* we store env in one partition of our nand */
#define CONFIG_SUNXI_ENV_PARTITION		"env"	/* the partition name */

/*------------------------------------------------------------------------
 * we save the environment in a nand partition, the partition name is defined
 * in sysconfig.fex, which must be the same as CONFIG_SUNXI_NAND_ENV_PARTITION
 * if not, below CONFIG_ENV_ADDR and CONFIG_ENV_SIZE will be where to store env.
 * */
#define CONFIG_ENV_ADDR				(53 << 20)  /* 16M */
#define CONFIG_ENV_SIZE				(128 << 10)	/* 128KB */
#define CONFIG_CMD_SAVEENV

#define CONFIG_EXTRA_ENV_SETTINGS \
	"bootdelay=3\0" \
	"bootcmd=run setargs_nand boot_normal\0" \
	"console=ttyS0,115200\0" \
	"nand_root=/dev/nandd\0" \
	"mmc_root=/dev/mmcblk0p7\0" \
	"init=/init\0" \
	"loglevel=8\0" \
	"setargs_nand=setenv bootargs console=${console} root=${nand_root}" \
	"init=${init} loglevel=${loglevel} partitions=${partitions}\0" \
	"setargs_mmc=setenv bootargs console=${console} root=${mmc_root}" \
	"init=${init} loglevel=${loglevel} partitions=${partitions}\0" \
	"boot_normal=sunxi_flash read 4007f800 boot;boota 4007f800\0" \
	"boot_recovery=sunxi_flash read 4007f800 recovery;boota 4007f800\0" \
	"boot_fastboot=fastboot\0"

#define CONFIG_SUNXI_SPRITE_ENV_SETTINGS	\
	"bootdelay=0\0" \
	"bootcmd=run sunxi_sprite_test\0" \
	"console=ttyS0,115200\0" \
	"sunxi_sprite_test=sprite_test read\0"

#define CONFIG_BOOTDELAY	1
#define CONFIG_BOOTCOMMAND	"nand read 50000000 boot;boota 50000000"
#define CONFIG_SYS_BOOT_GET_CMDLINE
#define CONFIG_AUTO_COMPLETE

/*
 * Miscellaneous configurable options
 */
#define CONFIG_SYS_LONGHELP				/* undef to save memory */
#define CONFIG_SYS_HUSH_PARSER			/* use "hush" command parser	*/
#define CONFIG_SYS_PROMPT_HUSH_PS2	"> "
#define CONFIG_SYS_PROMPT		"sunxi#"
#define CONFIG_SYS_CBSIZE	256			/* Console I/O Buffer Size */
#define CONFIG_SYS_PBSIZE	384			/* Print Buffer Size */
#define CONFIG_SYS_MAXARGS	64			/* max number of command args */

/* Boot Argument Buffer Size */
#define CONFIG_SYS_BARGSIZE			CONFIG_SYS_CBSIZE


/* Serial & console */
#define CONFIG_SYS_NS16550
#define CONFIG_SYS_NS16550_SERIAL
#define CONFIG_SYS_NS16550_REG_SIZE	(-4)		/* ns16550 reg in the low bits of cpu reg */
#define CONFIG_SYS_NS16550_CLK		(24000000)
#define CONFIG_SYS_NS16550_COM1		SUNXI_UART0_BASE
#define CONFIG_SYS_NS16550_COM2		SUNXI_UART1_BASE
#define CONFIG_SYS_NS16550_COM3		SUNXI_UART2_BASE
#define CONFIG_SYS_NS16550_COM4		SUNXI_UART3_BASE
#define CONFIG_NS16550_FIFO_ENABLE	(1)
#define CONFIG_CONS_INDEX			1			/* which serial channel for console */
/* valid baudrates */
#define CONFIG_BAUDRATE				115200
#define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }


/* common config */
#define CONFIG_CMDLINE_EDITING
#define CONFIG_USE_ARCH_MEMCPY
#define CONFIG_USE_ARCH_MEMSET
#define CONFIG_DOS_PARTITION
#define CONFIG_USE_IRQ

/*
 * Stack sizes
 * The stack sizes are set up in start.S using the settings below
 */
#define CONFIG_STACKSIZE        (256 << 10)	/* 256 KiB */
#ifdef CONFIG_USE_IRQ
#define CONFIG_STACKSIZE_IRQ    (4*1024)        /* IRQ stack */
#define CONFIG_STACKSIZE_FIQ    (4*1024)        /* FIQ stack */
#endif


#define BOOT_MOD_ENTER_STANDBY           (0)
#define BOOT_MOD_EXIT_STANDBY            (1)
#define FW_BURN_UDISK_MIN_SIZE           (2 * 1024)

/* fastboot */
#define FASTBOOT_TRANSFER_BUFFER        SDRAM_OFFSET(0x01000000)
#define FASTBOOT_TRANSFER_BUFFER_SIZE   (256 << 20)
#define FASTBOOT_ERASE_BUFFER           SDRAM_OFFSET(0x00000000)
#define FASTBOOT_ERASE_BUFFER_SIZE      (16 << 20)


#define CONFIG_OF_LIBFDT
#define CONFIG_OF_CONTROL
#define CONFIG_RELOCATE_SYSCONIFG      /*sysconfig.fex is relocate*/
#define CONFIG_ANDROID_BOOT_IMAGE      /*image is android boot image*/
#define BOARD_LATE_INIT                /* init the fastboot partitions */
#define CONFIG_SYS_LOAD_ADDR      0x50000000 /* default load address */


/****************************************************************************************
 *
 *      the fowllowing defines are used for boot0/sboot
 *
 ****************************************************************************************/
#define BOOT_PUB_HEAD_VERSION           "1100"
#define EGON_VERSION                    "1100"
#define CONFGI_SECURE_BOOT0_MAIN_VERSION    1
#define CONFGI_SECURE_BOOT0_SUB_VERSION     1

#define SUNXI_DRAM_PARA_MAX              32
#define CONFIG_SBROMSW_BASE              (CONFIG_SYS_SRAM_BASE)
#define CONFIG_HEAP_BASE                 SDRAM_OFFSET(0x00800000)
#define CONFIG_HEAP_SIZE                 (16 * 1024 * 1024)

#define CONFIG_TOC0_CONFIG_ADDR          (CONFIG_SYS_SRAM_BASE + 0x80)
#define CONFIG_TOC1_STORE_IN_DRAM_BASE   SDRAM_OFFSET(0x02e00000)

#define CONFIG_BOOT0_STACK_BOTTOM        CONFIG_NORMAL_BOOT_STACK
#define CONFIG_STACK_BASE                CONFIG_SECURE_BOOT_STACK



#ifdef CONFIG_SUN8IW16P1_NOR
#define CONFIG_TARGET_NAME      spinor-sun8iw16p1
#else
#define CONFIG_TARGET_NAME      sun8iw16p1
#endif
#define CONFIG_ARCH_SUN8IW16P1
#define CONFIG_ARM_A7
#define SUNXI_NCAT_VERSION1
#define CONFIG_SUPPORT_DDR4

/*******boot0 support dma for spinor init*******/
#define CONFIG_BOOT0_SUPPORT_DMA

/*******for boot0 loader kernel*******/
/* #define CONFIG_BOOT0_JUMP_KERNEL */
#ifdef CONFIG_BOOT0_JUMP_KERNEL
#define BOOT0_LOAD_KERNEL_START_SECTOR  (32)
#define BOOT0_LOAD_KERNEL_BUF           (0x45000000)
#define BOOT0_LOAD_KERNEL_ENTRY         (BOOT0_LOAD_KERNEL_BUF  + 0x40)
#endif


/*********************************************************************
 *platform memory map
 **********************************************************************/
#define CONFIG_SYS_SRAM_BASE             (0x20000) /* sram  */
#define CONFIG_SYS_SRAM_SIZE             (0x18000)
#define CONFIG_SYS_SRAMA2_BASE           (0x100000)
#define CONFIG_SYS_SRAMA2_SIZE           (0x1c000)
#define CONFIG_SYS_SRAMC_BASE            (0x38000)
#define CONFIG_SYS_SRAMC_SIZE            (130<<10)

#define PLAT_SDRAM_BASE                   0x40000000 /* dram */
#define CONFIG_SYS_SDRAM_BASE             0x40000000
#define SDRAM_OFFSET(x)                  (0x40000000+(x))
#define CONFIG_SYS_TEXT_BASE              0x43100000		/*uboot text*/

/*********************************************************************
 *boot0 run address config
 **********************************************************************/
#define CONFIG_BOOT0_RUN_ADDR            (0x20000)          /* sram a */
#define CONFIG_TOC0_RUN_ADDR             (0x20480)          /* sram a */
#define CONFIG_FES1_RUN_ADDR             (0x28000)          /* sram c */

#define CONFIG_BOOT0_RET_ADDR            (CONFIG_SYS_SRAM_BASE)
#define CONFIG_TOC0_RET_ADDR             (0)
#define CONFIG_FES1_RET_ADDR             (CONFIG_SYS_SRAMC_BASE + 0x7210)

#define CONFIG_STORAGE_MEDIA_NAND
#define CONFIG_STORAGE_MEDIA_MMC
#define CONFIG_STORAGE_MEDIA_SPINAND

/* normal boot0 set stack at sramc for spinand+nand */
#define CONFIG_BOOT0_SIZE_LIMIT          (64<<20)
#define CONFIG_NORMAL_BOOT_STACK         (CONFIG_SYS_SRAMC_BASE + CONFIG_SYS_SRAMC_SIZE)
#define CONFIG_SECURE_BOOT_STACK         (CONFIG_SYS_SRAMC_BASE + CONFIG_SYS_SRAMC_SIZE)



/*********************************************************************
 *CPUs and ATF run address config
 **********************************************************************/
#define SCP_SRAM_BASE                      (CONFIG_SYS_SRAMA2_BASE)
#define SCP_SRAM_SIZE                      (CONFIG_SYS_SRAMA2_SIZE)
#define OPTEE_BASE                           (0x41980000)
#define SCP_DRAM_BASE                      (0x4197b000)
#define SCP_DRAM_SIZE                      (0x4000)
#define SCP_CODE_DRAM_OFFSET		     (0x1C000)

/*fdt base*/
#ifdef CONFIG_SUNXI_FDT_ADDR
#undef CONFIG_SUNXI_FDT_ADDR
#define CONFIG_SUNXI_FDT_ADDR            (CONFIG_SYS_SDRAM_BASE+0x02000000)
#endif

/*********************************************************************
 *uboot common config support
 **********************************************************************/
/* #define CONFIG_SUNXI_SECURE_SYSTEM */
#define PMU_SCRIPT_NAME                 "charger0"
#define FDT_PATH_REGU                   "regulator0"
#define CONFIG_SUNXI_CORE_VOL           900

#define CONFIG_SUNXI_RSB_NCAT
#define CONFIG_AXP_USE_RSB

#define CONFIG_SYS_I2C_SPEED 400000

/*#define CONFIG_AUTO_UPDATE*/
#ifdef CONFIG_AUTO_UPDATE
#define CONFIG_SUNXI_MODULE_SDMMC
#define CONFIG_CMD_SUNXI_SPRITE
#define CONFIG_SUNXI_MODULE_SPRITE
#endif

#define CONFIG_GPADC_KEY

#define CONFIG_USB_MAX_CONTROLLER_COUNT 2
#define CONFIG_SUNXI_KEY_SUPPORT
/*#define CONFIG_SUNXI_KEY_BURN*/
/*#define CONFIG_SUNXI_DRAGONBOARD_SUPPORT*/
#define CONFIG_LZMA

#define FEL_BASE                         0x20
#define SUNXI_FEL_ADDR_IN_SECURE         (0x64)
#define SUNXI_RUN_EFEX_FLAG              (0x5AA5A55A)
#define SUNXI_RUN_EFEX_ADDR              (SUNXI_RTC_BASE + 0x108)

#define CONFIG_SUNXI_DMA
#define CONFIG_SUNXI_ARISC_EXIST
/*#define CONFIG_SUNXI_CHIPID
#define CONFIG_SUNXI_MULITCORE_BOOT
#define CONFIG_SUNXI_HDCP_IN_SECURESTORAGE*/
/*#define CONFIG_BOOTLOGO_DISABLE*/
/*********************************************************************
 *uboot cmd support
 **********************************************************************/
#define CONFIG_CMD_BOOTA		/* boot android image */
#define CONFIG_CMD_RUN			/* run a command */
#define CONFIG_CMD_BOOTD		/* boot the default command */
#define CONFIG_CMD_FDT
#define CONFIG_CMD_MEMORY
#ifndef CONFIG_SUN8IW16P1_NOR
#define CONFIG_CMD_IRQ
#define CONFIG_CMD_ELF
#define CONFIG_CMD_FASTBOOT
#define CONFIG_CMD_SUNXI_SPRITE
#define CONFIG_CMD_SUNXI_TIMER
#define CONFIG_CMD_SUNXI_EFEX
#define CONFIG_CMD_SUNXI_SHUTDOWN
#ifdef CONFIG_SUNXI_KEY_BURN
#define CONFIG_CMD_SUNXI_BURN
#endif
#define CONFIG_CMD_SUNXI_MEMTEST

#else
#define CONFIG_SUNXI_SPINOR_BMP
#endif


/*********************************************************************
 *module support
 **********************************************************************/
#ifndef CONFIG_SUN8IW16P1_NOR
#define CONFIG_SUNXI_SECURE_STORAGE
#define CONFIG_SUNXI_MODULE_SPRITE
#define CONFIG_SUNXI_MODULE_NAND
#define CONFIG_SUNXI_MODULE_SDMMC
#define CONFIG_SUNXI_MODULE_USB
/* #define CONFIG_GPT_SUPPORT */
#define CONFIG_SUNXI_MODULE_DISPLAY
#endif
#define CONFIG_CMD_FAT
#define CONFIG_CMD_SUNXI_BMP

#define CONFIG_SUNXI_MODULE_SPRITE
#define CONFIG_SUNXI_MODULE_SPINOR
#define CONFIG_SUNXI_MODULE_AXP

#ifdef CONFIG_SUNXI_MODULE_SDMMC
/* mmc config */
#define CONFIG_MMC
#define CONFIG_GENERIC_MMC
#define CONFIG_CMD_MMC
#define CONFIG_MMC_SUNXI
#define CONFIG_MMC_SUNXI_USE_DMA
#define CONFIG_STORAGE_EMMC
#endif
#define CONFIG_MMC_LOGICAL_OFFSET   (20 * 1024 * 1024/512)

#ifdef CONFIG_SUNXI_MODULE_NAND
/* Nand config */
#define CONFIG_NAND
#define CONFIG_STORAGE_NAND
#define CONFIG_NAND_SUNXI
#define CONFIG_SYS_MAX_NAND_DEVICE      1
#define CONFIG_SYS_NAND_BASE            0x00
#endif

#ifdef CONFIG_SUNXI_MODULE_SPINOR
#define CONFIG_SUNXI_SPI
#define CONFIG_SUNXI_SPINOR
#define CONFIG_SPINOR_LOGICAL_OFFSET        ((1024 - 16) * 1024/512)
#define UBOOT_START_SECTOR_IN_SPINOR        (64*1024/512)
#define SPINOR_STORE_BUFFER_SIZE            (2<<20)
#define CONFIG_STORAGE_MEDIA_SPINOR
#define ALIGN_SIZE_8K
#endif

#ifdef CONFIG_SUNXI_MODULE_USB
#define CONFIG_USBD_HS
#define CONFIG_USB_EHCI_SUNXI
/*for usb host*/
#ifdef CONFIG_USB_EHCI_SUNXI
	#define CONFIG_EHCI_DCACHE
	#define CONFIG_CMD_USB
	#define CONFIG_USB_STORAGE
	#define CONFIG_USB_EHCI
#endif

/*#define CONFIG_USB_ETHER*/
#ifdef CONFIG_USB_ETHER
/* net support */
#define CONFIG_CMD_NET
#define CONFIG_NET_MULTI
#define CONFIG_CMD_PING
#define CONFIG_CMD_NFS
/*
 * Reducing the ARP timeout from default 5000UL to 1000UL we speed up the
 * initial TFTP transfer or PING, etc, should the user wish one, significantly.
 */
#define CONFIG_ARP_TIMEOUT	1000UL

/* USB SUSPORT */
#define CONFIG_USB_ETHER
#define CONFIG_USB_ETH_RNDIS
#define CONFIG_USB_GADGET_DUALSPEED
#define CONFIG_USB_SUNXI_UDC0

#endif

#endif

#ifdef CONFIG_SUNXI_MODULE_DISPLAY
#define CONFIG_SUNXI_DISPLAY
#define CONFIG_VIDEO_SUNXI_V3
#ifndef CONFIG_SUN8IW16P1_NOR
/*#define CONFIG_SUNXI_MODULE_HDMI*/
#define CONFIG_SUNXI_MODULE_TV
#endif
#define CONFIG_SUNXI_LOGBUFFER
#endif


#ifdef CONFIG_SUNXI_MODULE_AXP
#define CONFIG_SUNXI_AXP
#define CONFIG_SUNXI_AXP21
#define CONFIG_SUNXI_AXP809
#define CONFIG_SUNXI_AXP_CONFIG_ONOFF
#define CONFIG_SUNXI_PIO_POWER_MODE
#endif

#ifdef CONFIG_GPT_SUPPORT
#define CONFIG_SUNXI_GPT
#define CONFIG_EFI_PARTITION
#define CONFIG_CONVERT_CARD0_TO_GPT
#endif

/* ethernet support */
/*#define CONFIG_SUNXI_GETH*/
#ifdef CONFIG_SUNXI_GETH
#define CONFIG_SUNXI_EXT_PHY
#define CONFIG_EPHY_CLK
#define CONFIG_CMD_NET
#define CONFIG_CMD_PING
#define CONFIG_HARD_CHECKSUM
#define CONFIG_CMD_MII
#define CONFIG_ETHADDR         72:D6:05:4F:B9:3B
#define CONFIG_IPADDR          192.168.200.254
#define CONFIG_SERVERIP                192.168.200.20
#define CONFIG_NETMASK         255.255.255.0
#define CONFIG_GATEWAYIP       192.168.200.1
#endif

/*#define CONFIG_SYS_DCACHE_OFF*/

#endif /* __CONFIG_H */

